Tento modul  editaci textu ve spodnm dku. Xlib samotn toti
nic takovho neum.

Napsan string je uloen v promnn \dl [char *]editpole. Na ni
ukazuje promnn \dg [char *]text_pole. Obvykle je tedy
"text_pole" a "editpole" to sam. Zane se to liit a
v~nestandardnch ppadech, napklad pi prochzen historie.

\ifirst {edit.c}{editpole}{text_pole}{++}

Neukldm vak zde string standardnm C-kovm zpsobem. Pole
"editpole" nen zakoneno nulou, ale msto toho je dlka stringu
uloen v promnn \dl [int] delka. Dle je tu promnn cursor, kter
uruje msto v textu, kam se pe. Pokud "cursor == 0", je kursor
nejvce vlevo, a kdy "cursor == delka", tak je nejvc vpravo.

\ifirst {edit.c}{cursor}{delka}{++}

Funkce \dg [void] loadfont() nate font ze stringu \dg [char] FONTNAME
a nastav souvisejc promnn. Je nastavena vka oknka s textem
("text_vyska"), dle \dl [int] kursor_vyska, co udv vku
kursoru, kter ovem nen stejn jako "text_sirka", ale je u o
"HOT" (horn okraj textu ) a "DOT" (doln okraj textu). Promnn
\dl [int] font_y udv vzdlenost od hornho okraje "textwin" k a,
tedy ypsilonov souadnice, co se m pout pi vykreslen textu.

\insf loadfont

Text je pak zobrazen v okn "textwin". K tomu mam jet dv
promnn. Promnn \dl [int] gelka (grafick dlka) uruje vzdlenost
konce textu od zatku textovho polka a promnn \dl [int] gursor
(grafick cursor) uruje vzdlenost kursoru od zatku textovho
polka. V ppad, e je text przdn, tedy "delka = 0", tak promnn
"gelka" i "gursor" jsou nastaveny na "LOT" (lev okraj textu).

Text vykresl funkce \dg [void] redrawtext(). Promnn "posunuti" m zpornou
hodnotu jen v ppad, e je text zobrazen poprv. V takovm ppad je
spotena poten "gelka" a "gursor". Funkce "redrawtext" je volna
po rozshl prav textu nebo pi odkryt okna.

\insf redrawtext

Funkce \dg [void] cleartext() text smae, pouze vak graficky. Tedy
vyist textov polko.

\insf cleartext

Kursor je bl obdlnek, jeho lev okraj je na pozici "gursor" a m
ku podle hodnoty "KURSIR". Vykresl ho funkce \dg ukazkursor().

\insf ukazkursor

Funkce \dg [void] smazkursor() kursor smae.
To je o nco sloitj ne jeho vykreslen, protoe je
teba pak jet znovu vykreslit psmenko, kter bylo pod
nm. Pedpokld se, e kursor natolik zk, e se pod nj vejde jen
jedno psmenko.

\insf smazkursor

Zklad editace textu je psan psmen. Pi stisku klvesy, kter je
znakem, je zavolna funkce \dg [char] pripisznak (). Tato funkce
dostane znak kter m pipsat. Pokud je ji pole pln, vrt
nulu. Jinak pipe znak do msta kursoru a pak bude nvratov hodnota
zporn v ppad, e byl znak pipsn na konec. Nvratov hodnoty
jsou vyuity pi vybrn soubor.

Tato funkce mus jak graficky, tak v poli posunout znaky ped napsanm
znakem.

\insf pripisznak

Dal editan funkce je \dg [char] delete(), kter jeden znak
smae. Tato funkce dostane parametr, kter, kdy je true, tak bude
smazn znak ped kursorem, jinak bude smazn znak za kursorem.
Pokud se smazn poda vrt funkce jedniku, jinak vrt nulu.

\insf delete

Kursor samozejm mohu posunovat. Obecn funkce pro tento el je
\dg [void] posunkursor(). Tato funkce m jeden parametr, kter uruje,
zda se m kursor posunout na konec, na zatek, doleva nebo doprava.

\insf posunkursor

Pi zmknut enteru se spust \dg [void] text_enter(), co text
vynuluje a provede.

\insf text_enter

Pi zmknut tabeltoru se spust funkce \dg [void] prepniokraj(). Ta
dostane parametr o tom, zda se m okraj pepnout na text (true) nebo
na okno (false).

\insf prepniokraj

Pipisovnm psmen by se mohlo stt, e mi kursor utee mimo
obrazovku. To vak nen douc. Proto je mon text posouvat.
To, o kolik pixel je text posunut smrem doleva, udv promnn
\dl [int] posunuti.

\ifirst {edit.c}{posunuti}{}{++}

I kdy je text posunut, "gursor" i "gelka" se stle vztahuje
k~zatku okna a nikoliv k zatku textu. Pi zmn promnn "gursor",
"gelka" i "text_sirka" je zavolna funkce \dg [char] posuntext(). Pokud tato
funkce usoud, e je vhodn text posunou, vrt true, zmn
promnn "posunuti", "gelka" a "gursor" a tuto zmnu aplkuje i
graficky. Tud po spnm posunut textu nen teba ji eit
grafick zleitosti.

Funkce "posuntext" se sna o splnn nsledujcch podmnek, piem
podmnky, co jsou napsny ve maj vy prioritu:

\begitems
\item 1) Lev okraj textu bude "LOT" pixel od okraje oknka nebo vce vlevo.
         \hfil\break Tedy "posunuti >= 0".
\item 2) Prav okraj textu bude "POT" pixel od okraje oknka nebo vce vpravo.
         \hfil\break Tedy "gelka <= text_sirka-POT".
\item 3) Kursor bude alespo "STRKAL" pixel od okraje.
         \hfil\break Tedy "gursor >= STRKAL && gursor <= text_sirka-STRKAP".
\item 4) Text se posune co nejmn. Tedy "ppos" bude minimln.
\enditems

\insf posuntext

\subsec historie

Vdy, kdy je odenterovn njak neprzdn text, je uloen do
historie. Historie je zastoupena polem string \dl [char **]history,
kter m dlky \dg MAXHISTORY. Stringy v tomto poli vak jsou
standardn C-kovsk, tedy zakoneny nulou.

\ifirst {edit.c}{char *history}{}{++}

Nejprve je historie uloena do "history[0]", pak do "history[1]", pak
do "history[2]", ... Index pole, do kterho byla historie naposledy
uloena je uloen v promnn \dl [int] poslhist. V ppad, e jt
dn historie uloena nebyla, "poslhist = -1".

Pokud u je zaplnna cel historie, tedy "poslhist == MAXHISTORY-1",
ukldm dal historii opt do "history[0]", "history[1]", ..., m
pepisuji tu pvodn. Jakmile zanu takto pepisovat pvodn historii,
nastavm \dl [char] cyklhist na true. Do t doby je "cyklhist" false.

\ifirst {edit.c}{poslhist}{cyklhist}{++}

Pi prochzen historie pouvm promnnou \dg [int] aktuhist. Pokud
je tato promnn nastavena na hodnotu $-1$, nejsem vbec v historii a
"text_pole" je nastaveno na "editpole". Pokud "aktuhist == -2", jsem
v~przdnm dku. Tento przdn dek je to nejspodnj, co
v~historii je. Nad nm je "editpole", nad nm "history[poslhist]" a dl
u pokrauje obvykl historie.

V ppad, e "poslhist = 3" a "cyklhist = 0" historie tedy vypad
zhruba takto: 

\begtt
history[0]   aktuhist =  0
history[1]   aktuhist =  1
history[2]   aktuhist =  2
history[3]   aktuhist =  3
editpole     aktuhist = -1
nic          aktuhist = -2
\endtt

Funkce \dg [void] ulozhist(), ulo aktuln text do historie. Je v n
implementovan jet takov featura, e zkontroluje, zda je ukldan
text shodn s poslednm uloenm a pokud ano, tak ho
neukld. Domnvm se, e text, kter je v historii uloen dvakrt po
sob, tam akort pek.

\insf ulozhist

Pro brouzdn histori se pouv funkce \dg [void] zkoumejhist(),
kter podobn jako funkce "posunkursor" m parametr "jak".

\insf zkoumejhist

V ppad, e utkm z "editpole", ulom si promnn "cursor",
"delka", "gursor", "gelka" a "posunuti" pomoc funkce \dg [void]
zalohujtext() do promnnch \dl [int] ocursor, \dl [int] odelka, \dl
[int] ogursor, \dl [int] ogelka a \dl [int] oposunuti.

\insf zalohujtext

A se do "editpole" vrtm, zrestauruji ve zmnn promnn funkc
\dg [void] odzaltext(). Tyto dv funkce tak umouj ostatnm modulm
se do tchto statickch promnnch dostat.

\insf odzaltext

Funkce \dg [void] dohistory() aplikuje "aktuhist", tedy nastav
pslun "text_pole", "delka", "cursor", "gelka", ...

\insf dohistory

Otzka je, co se stane, kdy jsem v historii a zanu njakm zpsobem
editovat. Nkter programy funguj tak, e tm zmnm historii. J
vak zastvm nzor, e co se stalo se stalo a e historie je tu jen
pro prohlen. Tud kdy zanete historii editovat v tomto programu,
pepnete se opt dku "editpole", kde probhne prava. Kdy se pak
podvte ipkou nahoru do historie, shledte pvodn text
nezmnn. Samoejm se tm vak pepe to, co bylo v promnn
"editpole" pedtm.

V editanch funkcch je tedy ped provedenm pravy zavolna funkce
\dg [void] edithist(), kter zaru editaci "editpole".

\insf edithist

Dle stoj za povimnut, co vlastn udl v textovm mdu klvesa
Escape. Ta toti pepne okraj na "win" a zdnliv vymae text. Ve
skutenosti jen pepne historii na przdn dek. Stane se tedy to
sam jako kdy zmknete PgDown a Tabeltor.

\insf text_escape

\subsec Funkce pro ostatn

V tomto modulu jsou statick promnn, kter by rdy mnly i jin
moduly. Prvn dv promnn jsou uren pro modul \cite gsl[m:gsl].
Funkce \dg [void] zmentext() dostane ckovsk string a ten
zkopruje do "text_pole", piem nastav i promnn "cursor",
"delka", "gelka" a "gursor".

\insf zmentext

Funkce \dg [char *]textcstr() funguje obrcen ne "zmentext". Tato
funkce vrt C-kov string, kter je zkonvertovan z "text_pole",
kter je nejastji stejn pointer jako "text_pole". V opanm ppad
to je namallokovan string.

\insf textcstr

Dal dv funkce jsou uren pro moduly \cite save a
load[m:save]. Funkce \dg [void] save_hist() ulo historii pomoc
ukldacch funkc. Nejprve ulo poet uloench histori, pak
aktuln historii, potom dlky uloench histori, piem na zatku
a nakonec ulo znaky. Pitom ukld editpole stejn jako jednu
z histori.

\insf save_hist

Funkce \dg [void] apply_loaded_hist() dostane pole, dlku historie a
aktuln historii. Posledn prvek pole je uloen do "editpole" a ostatn
do historie.

\insf apply_loaded_hist