#define AUTOU_SOUR  0
#define AUTOU_POST  1

struct kq_animpost{
  int x,y;
  union{
    kq_pixmap **pole;
    kq_pixmap *map;
  } pix;
  int framu, tim;
  char jednopol, porad;

  char lokalni;
  kq_animpost *next;
  int cislo;
};

struct kq_postava{
  int x,y,xx,yy;
  kq_timer *tim;
  char zdi, barvy, odraz, odejde;

  kq_submap *submap;
  int sm_x, sm_y;

  int chyt_vzdal;
  void (*chyt_func)(kq_postava *post);

  void (*auto_func)(kq_postava *post);   // funkce pro sledovani
  char autou_typ;    // souradnice nebo postava
  union{
    kq_postava *sledpost;
    struct{
      int x, y;
    } sourad;
  } auto_u;
  kq_timer *auto_tim;

  void (*free_func)(kq_postava *post);

  kq_animpost *animace;
  char smer;
  int animstav;
  kq_timer *animtim;
  float xz, yz, z;
  kq_widget *widget;

  char lokalni, hide, zmena;
  kq_postava *next;
  int cislo;
};

kq_animpost *prvanip, *fixed_anips;
int pocet_fixanip;

kq_postava *prvpost;

char menpost;

kq_animpost *nactianip(int x, int y, char *filename, int framu, int tim,
			  char jednopol, char porad, char lokalni); 

void zmenanip(kq_postava *post, kq_animpost *anip);
void anip_step(kq_postava *post);
void freeanip(kq_animpost *anip);
void deletelanips();
void deleteAanips();
void fix_anips();

kq_postava *vytvorpost (int x, int y, int smer, int tim,
			    float tprior, char lokalni, char hide);

void zmenapost(kq_postava *post);
void updateposts();

void zkuschytit(kq_postava *post);

int posunpost(kq_postava *post, int x, int y);
void jdipost(kq_postava *post);

void hidepost(kq_postava *post);
void unhidepost(kq_postava *post);
void znicpost(kq_postava *post);
void deletelposts();
void deleteAposts();

void post_submap(kq_postava *post, char *nazev, int x, int y, float z);
void post_z(kq_postava *post, float xz, float yz, float z);

void getchytsour(kq_postava *post, int *x, int *y);
void setchytsour(kq_postava *post, int x, int y);
void setchytpost(kq_postava *post, kq_postava *sledpost);
void autopost(kq_postava *post, void (*auto_func)(kq_postava *post), int prvcas, int cas);
