
Program potebuje ukldat a vyhledvat slovnkov daje. Napklad pi
analze vty, kterou vkld uivatel, je poteba vtu rozebrat na
slova a podvat se do slovnku, zda takov slova znme a co
znamenaj. Nebo keybinding, \vizmod[keybindings].
Pro tyto ely se v programech bn implementuje tzv. hash.
Jedn se o implemantaci slovnku, kter obsahuje mnoinu uspodanch
dvojic 
\medskip
[kl (slovo), hodnota (jak reagovat)]. 
\medskip
Bude poteba eit
dotazy, kdy znme kl, a hledme hodnotu. Hash je inteligentn
implementace slovnku, kdy program nevyhledv mezi jednotlivmi kli
sekvenn, ale ponkud rychleji. Viz Knuth: The Art of Computer
Programming, dl 3, strany 513--557. V programu jsem pouil variantu
algoritmu popsanho v uveden knize na stran 520.

Kl ve slovnku nebude v mm programu slovo samotn, ale jet k nmu
pidm typ slova. Slova stejn znjc rznho typu toti vyaduj
pln jinou reakci. Nsleduje vet typ slov.
\dgn WORD \dgn WORDPART \dgn WORDCAT \dgn BINDTEXT \dgn BINDWIN
\dgn OUTPUT \dgn OTHERHASH

\ins h typy-slov

Hodnota ve slovnku (jak reagovat) je implementovan datovm typem "kq_pin"
\vizmod[pin].

Slovnk je implementovn jako pole \dg [struct hash **]hashtable dlky \dg HASHSIZE

\ins h hashsize

Dlka pole se podle doporuen vol jako prvoslo zhruba tak
velk, jak velk oekvme slovnk. Hodnoty pole jsou pointery do
struktury "hash":

\ins h struct-hash

Kad kl dostane pidleno pomoc hashovac funkce slo v rozsahu
"0..HASHSIZE-1", kter je indexem v poli "hashtable". Pokud se sejdou dva
nebo vce rznch kl se stejnou hodnotou hashovac funkce, je nutno
etzit jednotliv struktury "hash", jak ukazuje obrzek. Pole "hashtable"
o velikosti "HASHSIZE" je na obrzku zakresleno svisle vlevo. Nap.
"kl1" m na obrzku hashovac index 3 stejn jako "kl5". M-li 
se vyhledat hodnata ke "kl5", program vyhodnot index 3 a dle projde 
\uv{dek} na obrzku sekvenn.

\ifig .5 hash 

Funkce \dg [void]inithash() vynuluje "hashtable" a pouije se na zatku
programu.

\ins c inithash

Funkce \dg [int] hashfunc() pidl ke kli hashovac hodnotu, tj. index do
pole "hashtable". Protoe kl je v~naem ppad dvojice [typ, slovo],
m funkce odpovdajc parametry "typ", "s".

\ins c hashfunc

Funkce \dg [void] hash_add() pracuje ve dvou mdech: Je-li parametr "informace"
roven NULL, pak vymae ze slovnku daj tkajc se kle "[typ,s]"
(pokud takov kl neexistuje, jinak v tomto mdu nedl nic).
Je-li "informace" rzn od NULL, pak je ukazatelem na hodnotu, kterou
funkce pidl kli "[typ,s]". Pokud v~takovm ppad ve slovnku
dan kl existuje, jeho hodnota se pepe novou hodnotou, jinak se
zalo do slovnku nov dvojice [kl,hodnota].

\ins c hash_add

Pi pepisovn nebo mazn pvodn informace je nkdy teba odallokovat
jej pointer nebo vypsat varovn v zvislosti na typu. To e funkce
\dl [void] uklid().

\ins c uklid

Konen funkce \dg [kq_pin] hash_find() m parametr "[typ,s]", tedy kl, a vrt
ukazatel na hodnotu, pokud spn kl ve slovnklu nala. 
Jestlie kl ve slovnku nen, vrt NULL.

\ins c hash_find

