\def\modload{\endnamespace\namespace{##1./load}\def\modulename{load}}
\def\modsave{\endnamespace\namespace{##1./save}\def\modulename{save}}
\def\inss{\modsave\ins}
\def\insl{\modload\ins}

\sec [m:save] Moduly save a load \par
\modsave

Modul save e ukldn aktuln pozice do souboru. Z tohoto souboru
me bt tato pozice natena pomoc modulu load.

\subsec Zkladn natac a ukldac funkce

Pi ukldn je teba nejprve otevt soubor do promnn
\dl [FILE *]soubor. To dl funkce \dg [void] save_start(). Krom toho
piprav dal promnn souvisejc s~ukldnm. Jedna z nich je
promnn \dl [char] chyba, kter, pokud je nastavena na true, zna,
e nco nen v podku a je tedy nejlep ukldn ukonit.

\ins c soubor
\ins c save_start

Do tohoto souboru je ukldno pomoc funkce \dg [void] save_bit(), o
kterou se opraj vechny dal funkce, kter nco ukldaj. Tato
funkce pouv statick promnn \dl [unsigned char] byte a \dl [char]
bpos. Promnn "byte" slou jako loit uloench byt ne jich
bude dost na to, aby se daly zapsat do souboru. Promnn "bpos"
urje, do kterho bitu v promnn "byte" bylo naposledy zapsno. Tato
promnn se posunuje od sedmi do nuly, piem 7 je bit nejvce vlevo
a 0 bit nejvce vpravo. \dg JEDNA je definovno jako byte, kter m
pouze bit, kter je nejvce vpravo je jednikov. Nejsem si toti
jist, e to slo 1 vdy spluje.

\ifirst {save.h}{CSL}{}{++}
\ins c byte
\ins c save_bit

Nakonec je teba uloit posledn byte a uzavt soubor, co dl
funkce \dg [void] save_end().

\ins c save_end

\modload

Podobn funguje i natn souboru. Funkce \dg [void] load_start()
oteve soubor do promnn \dl [FILE *]soubor a piprav i dal
promnn. Promnn \dl [char] chyba m opt stejnou funkci jako v
modulu save, tedy upozornit funkce na to, e nco nen v podku
(napklad se nepodailo nast soubor).

\ins c soubor
\ins c load_start

Funkc \dg [char] load_bit() jsou z tohoto souboru teny bity. Tato
funkce podle toho vrt jedniku nebo nulu. Opt k tomu vyuv
promnnou \dl byte, do kter si vdy nate znak ze souboru a pak z n
te bity. Pro uren, kter bit m bt naten, je zde opt promnn
\dl bpos.

\ins c byte
\ins c load_bit

Nakonec se zkontroluje, jestli v souboru nco nezbylo a soubor se
zave. To provede funkce (kdo by to ekal) \dg [void] load_end(). Tato
funkce navc opt me dostat v parametru nzev loadovanho
souboru. Pokud ho dostane, touchne dan soubor, tedy zaktualizuje as
modifikace. Toto nen provedeno, pokud natn skonilo chybou nebo
je parametrem "NULL".

\ins c load_end

\modsave

Program by ml st pouze takov soubory, kter si sm vytvoil, take
si do nj ukd kontroln souty. Pi ukldn/natn bit jsou
potny kontroln souty a nakonec je mon tyto souty
uloit/zkontrolovat funkc "save_cs"/"check_cs". Po tom se daj opt
ukldat/natat dal informace, ale ty u nejsou zahrnuty v tomto
kontroln souty. Je vak mon uloit/zkontrolovat dal kontroln
souet.

Pro potn kontrolnch sout zde
je funkce \dg [void] zapiscs(). Tato funkce je velmi obecn. Dostane
pole (parametr "cs") o urit dlce (parametr "delka"), ukazatel na
index do tohoto pole (parametr "cspos") a parametr "co". Pak dan
msto v poli vyxoruje s parametrem "co" a posune index do pole o jedniku.

\ins c zapiscs

Ve funkci "save_bit" a "load_bit" se funkce "zapis_cs" zavol
dvakrt. Jednou na pole \dl [char *]cs1
\modload \dlh [char *]cs1 \modsave
o dlce "CSL", tedy 6, a index \dl [int] cs1pos
\modload\dlh [int] cs1pos \modsave
a podruh na pole \dl [char *]cs2
\modload\dlh [char *]cs2 \modsave
o dlce "CSL+1", tedy 7, a index \dl [int] cs2pos.
\modload\dlh [int] cs2pos
Vznikaj tedy dva v podstat nezvisl kontroln souty. Kontrola,
kontrolnho soutu je jednoduch. Funkce \dg [void] check_cs() pete
"CSL*2", tedy 12 bit a pak zkontroluje, zda jsou ob pole vynulovna.

\dgn CSL
\ifirst {save.h}{CSL}{}{++}
\ins c cs
\ins c check_cs

\modsave
Uloit tchto 12 bit u je sloitj. Dl to funkce \dl [void]
save_cs(). Pro demonstraci danho algoritmu pouiji nsledujc obrzek.

\ifig 0.8 checksum

Vsledn pole je pole onch dvancti bit, kter chci uloit.
Ulom si do lokln promnn "ch" nulu a jdu podle ipek. Kdy projdu
polkem z hornho nebo spodnho pole, Kdy projdu blm polkem,
vyxoruji "ch" s hodnotou v tom polku a kdy projdu svtle modrm
polkem, tak tam "ch" zapu. Na konci bude "ch" opt nulov, protoe
poet vech jedniek v obou kontrolnch polch ("cs1" a "cs2") je
sud. sla pod blmi polky jsou indexy tchto pol za situace, kdy
"cs1pos = 2" a "cs2pos = 6".

\ins c cs
\ins c save_cs

Krom bit je dobr umt ukldat i jin datov typy. Prvn datov typ,
kter vysvtlm je trit, kter se d uloit funkc \dg [void]
save_trit() a pak nast funkc \dg [char] load_trit(). Trit nco
podobnho jako bit, ale me to nabvat t hodnot: Zporn, nulov a
kladn. Pokud je nulov, bude do souboru uloen bit "0", pokud je
hodnota kladn, jsou do souboru uloeny bity "10" a funkce "load_trit"
pak vrt jedniku. Kdy je zporn, jsou do souboru uloeny bity "11"
a funkce "load_trit" vrt minus jedniku. Tato funkce je dobr pro
ukldn hodnot poloky "lokalni" ve strukturch "kq_timer",
"kq_widget", "kq_submap" a "kq_post".

\ins c save_trit
\insl c load_trit

Funkce \dg [void] save_unsint() ulo nezporn slo, kter se pak
d pest funkc \dg [unsigned int] load_unsint(). Toto slo me bt
teoreticky libovoln velik, pokud by takto velik mohl bt i datov
typ "unsigned int". slo je pevedeno do trojkov soustavy s
slicemi 1, 2 a 3. Pklady sel takovch sel:

\begtt
0 = ""    4 = "11"   8 = "22"  12 = "33"
1 = "1"   5 = "12"   9 = "23"  13 = "111"
2 = "2"   6 = "13"  10 = "31"  14 = "112"
3 = "3"   7 = "21"  11 = "32"  15 = "113"
\endtt

Tuto posloupnost slic zakonm nulou a kadou cifru ulom pomoc
dvou bit: "0 = 00", "1 = 01", "2 = 10", "3 = 11".

\inss c save_unsint
\insl c load_unsint

Kdy u umm uloit nezporn slo nen problm uloit cel
slo. Jednodue si do prvnho bitu ulom, jestli je toto slo
zporn. Cel sla ukldm pomoc funkce \dg [void] save_int().

\inss c save_int

Potom je mon cel slo opt pest pomoc funkce \dg [int]
load_int().

\insl c load_int

Krom libovoln velkho sla mohu ukldat i sla, o kterch vm, e
jsou v uritm rozsahu (a budu to vdt i pi natn). e to
funkce \dg save_intoddo, kter krom prvnho parametru sla, kter
chci uloit, dostane druh parametr (nejni mon slo) a tet
parametr (nejvy mon slo). Tato funkce funguje na principu
plen interval. Rozpl interval, kter dostane a pak zavol sama
sebe na interval, kde se ukldan slo nalz. Tsn pedtm ulo do
souboru bit o tom, kter interval si vybrala. Tato rekurze skon
v~okamiku, kdy interval obsahuje u jen jedno slo, tedy to, kter
m bt uloeno. Pravda msto rekurze by stailo pout jednoduch
cyklus i goto konstrukci, takhle se mi to vak jev nejpehlednj.

\inss c save_intoddo

Takto uloen slo se d pest funkc
\dg [int] load_intoddo(). Tato funkce mus dostat stejn parametry,
jako byly dny funkci "save_intoddo" krom prvnho, tedy ukldanho
sla. Toto ukldan slo vrt jako nvratovou hodnotu. Funguje na
stejnm principu jako ukldac funkce. Rozpl interval, pete si,
kterou plku si m vybrat a zavol sama sebe. Jakmile interval
obsahuje u jen jeden len, tedy jeho krajn body se shoduj, je
vrcena hodnota krajnch bod.

\insl c load_intoddo

Dle umm pomoc funkce \dg save_char() ukldat znaky. Tento znak je
ukldn po bitech, take ance, e bude tento znak zobrazen v textovm
editoru sprvn je $1\over8$.

\inss c save_char

Takto uloen znak se pak samozejm d pest funkc \dg
load_char().

\insl c load_char

Nyn pechzm k dal kontroln funkci a to je funkce \dg
check_idstr(), kter zkontroluje identifikan string. To je string,
kter je uloen v promnn "ident_str". Pokud tam dn string
uloen nen, funkce "check_idstr" nedl nic.

Jinak postupn te znaky
ze souboru a kontroluje je se znaky ve stringu "ident_str" vetn
znaku 0. Pokud se njak znak neshoduje nastav promnnou "chyba" na
true, take soubor nebude naten. J tuto funkci spoutm na zatku
natn ze souboru, ale je mon ji spustit kdykoliv.

\ins c check_idstr

Pro uloen identifikanho stringu \dg [char *]ident_str do souboru slou funkce
\dg [void] save_idstr()

\inss c save_idstr

Tak mohu uloit libovoln jin string funkc \dg [void]
save_string(). Tato funkce ukld string v jinm formtu ne funkce
"save_idstr". Nejprve ulo dlku stringu a pak jeho znaky. Nen
ukldn koncov byte 0.

\ins c save_string

V tomto formtu je string ukldn proto, aby natac funkce
\dg [char *]load_string() si mohla hned na zatku naalokovat pole
pslun dlky.

\insl c load_string

Dal datov typ, kter mohu uloit, je "float". Ten vak mohu uloit
jen s uritmi omezenmi:

\begitems
\item 1) Ulom maximln 3 desetinn msta.
\item 2) Neulom slo, kter se nevejde do intu
\enditems

Typ "float" se ukld funkc \dg save_float(). Nejprve se ulo pomoc
dvou bit poet desetinnch mst ($i \in \langle 0; 3\rangle$), pak se
ukldan slo vynsob slem $10^i$ a ulo se jako cel slo.

\inss c save_float

Nast "float" pak mohu funkc \dg [float *]load_float().

\insl c load_float

\modsave
\subsec Ukldn vnitnch struktur

Zde em dv vci. Za prv, jak uloit pointer na njakou strukturu
jak uloit vechny pixmapy, widgety, submapy, timery, postavy a
animace postavy.

\noactive{cele cislo}
\noactive{realne cislo}
Prvn problm em pomoc poloky \dg cislo, kter je ve strukturch:
"kq_pixmap", "kq_widget", "kq_submap", "kq_animpost", "kq_postava",
"kq_timer" a "kq_policko". Hodnotu poloky "cislo" tedy jednodue ulom
do souboru pomoc funkce "save_intoddo". slo 0 je
rezervovno pro pointer "NULL", kladn sla uruj poad tohoto
pointeru ve standartnm seznamu tto struktury a zporn sla pro
njak jin seznam stejnho typu (schovan timery, zapausovan timery
a schovan submapy, zafixovan pixmapy a zafixovan animace postavy).

Poad nkterch struktur se vak v prbhu hry mn a nen jednoduch
stle udrovat aktuln. V takovch struktuch nastavm poloku
"cislo" pouze na zatku ukldn do souboru, tedy ve funkci
"save_pocty". Pouze pro polka a zafixovan struktury nen teba toto
poad potat. Ve funkci "save_pocty" tak spotm poty
jednotlivch struktur a ulom to do globlnch statickch promnnch
zanajcch na "pocet_".
Poty struktur, kter se v prbhu hry
nemn zde potny nejsou a potaj se u pi vytven
("pocet_fixpix", "pocet_pol", "pocet_fixanip" a "pocet_func").

Dal vjimkou jsou barvy, kde poloka slo vbec nen a je tedy
teba projt cel seznam aktulnch barev, tedy tch, kter jsou bu
globln nebo jsou lokln v aktulnm polku. Prochzm to proto,
abych zjistil, zda podvan barva je aktuln. Funkce, kter ulo
pointer na barvu se jmenuje \dg [void] save_color().

\ins c save_color

Struktura animwid nem poloku "cislo". Pedpokldm, e kad ukazatel
na tuto strukturu je ukazatelem do pole "animpole". Cel funkce
\dg [void] save_awid() je v podstat jen pro ukldn timer s funkc "animuj".

\ins c save_awid

Dal funkce, kter ukldaj pointer jsou dost podobn:

Uloen pointeru na slovo:
\dgn [void] save_word()
\ins c save_word

Uloen pointeru na pixmapu:
\dgn [void] save_pixmap()
\ins c save_pixmap

Uloen pointeru na widget:
\dgn [void] save_widget()
\ins c save_widget

Uloen pointeru na submapu:
\dgn [void] save_submap()
\ins c save_submap

Uloen pointeru na animaci postavy:
\dgn [void] save_anip()
\ins c save_anip

Uloen pointeru na postavu:
\dgn [void] save_post()
\ins c save_post

Uloen pointeru na pedmt:
\dgn [void] save_predmet()
\ins c save_predmet

Uloen pointeru na timer:
\dgn [void] save_timer()
\ins c save_timer

Uloen pointeru na polko:
\dgn [void] save_pol()
\ins c save_pol

Tm bych ml vyeen prvn problm a jdu eit ukldn samotnch
struktur. Funkce, kter by mla bt zavolna ped
natnm vech monch struktur i pointer na n, tedy \dg [void]
save_pocty, udl nsledujc
operace:

\begitems
\item * Zape do poloky "cislo" vech monch vnitnch astruktur
        jej poad.
\item * Spot poty pixmap, widget, schovanch widget, ... a ulo
        je do globlnch statickch promnnch zanajcch na "pocet_"
\dlh [int] pocet_pix \dlh [int] pocet_wid \dlh [int] pocet_hwid \dlh [int] pocet_sm
\dlh [int] pocet_hsm \dlh [int] pocet_anip \dlh [int] pocet_post \dlh [int] pocet_tim
\dlh [int] pocet_ptim \dln [int] pocet_predmet
	Pokud pot seznam, kter pouv zpornou poloku "cislo",
	bude i odpovdajc promnn zporn.
\item * Tyto poty ulo do souboru pomoc funkce "save_unsint"
\item * Ulo aktuln polko
\item * Nakonec ulo kontroln souet.
\enditems

\ins c save_pocty

Nezvisl na funkci save_pocty je jen funkce
\dg [void] save_kontexts(). Tato funkce projde vechna slova a ulo
do souboru bit, zda je toto slovo prv v kontextu

\ins c save_kontexts

Pi ukldn dat ve widgetech Povm pomocnou funkci \dg [void]
save_winfo(), kter ulo data z jednoho widgetu. Tato funkce neulo
poloku "hide", protoe jej hodnota je jasn u z toho, v jakm
seznamu se nachz.

\ins c save_winfo

Ve funkci \dg [void] save_widgets(), kter m widgety vlastn uloit,
projdu vechny widgety a zavolm na n funci "savewinfo".

\ins c save_widgets

Podobn pro ukldn dat v submap mm funkci \dg save_sminfo(). Pi
ukldn submapy neulom jej pixely, ale jen nzev souboru, ze
kterho byla natena. Stejn jako u widget neulom poloku "hide".

\ins c save_sminfo

Funkce \dg [void] save_submaps() projde vechny submapy a zavol na n
funkci "save_sminfo". Krom toho ulo pointer na "bgmap".

\ins c save_submaps

Takovm zpsobem ukldm i timery. Funkc \dg [void] save_tinfo()
ulom data v jednom timeru. Stejn jako u widget a submap neukldm
poloku hide.

\ins c save_tinfo

A funkc \dg [void] save_timers() projdu vechny timery a ulom
je funkc "save_tinfo". Neulom ovem timer "aktutimer", protoe se
domnvm, e je zde ponkud nepodstatn. Ve funkci "save_pocty" dostal
"aktutimer" pidleno slo 0, take bude pointer na nj ukldn
stejn jako "NULL".

\ins c save_timers

V dalch funkcch ji nebudu potebovat funkci, kter ulo data
z~jedn poloky, protoe u ve uloim v jednom cyklu.

Pi ukldn pixmap funkc \dg [void] save_pixmaps(), stejn jako u
submap, ukldm pouze nzev souboru, ze kterho byla natena a ne
samotn pixely.

\ins c save_pixmaps

Ukldn animac postav:
\dgn [void] save_anips()
\ins c save_anips

Ukldn postav:
\dgn [void] save_posts()
\ins c save_posts

Ukldn pedmt:
\dgn [void] save_predmets()
\ins c save_predmets

Ukldn animac polka:
\dgn [void] save_awids()
\ins c save_awids

\modload
\subsec Natn vnitnch struktur

Natn, podobn jaku ukldn, zan funkc "load_pocty". Tato
funkce si pete ze souboru poty jednotlivch struktur a ulo je do
statickch promnnch zanajc na "pocet_".

\dln [int] pocet_pix \dln [int] pocet_wid \dln [int] pocet_hwid \dln [int] pocet_sm
\dln [int] pocet_hsm \dln [int] pocet_anip \dln [int] pocet_post \dln [int] pocet_tim
\dln [int] pocet_ptim \dln [int] pocet_predmet
\ins c pocty

Tak zjist aktuln polko. Potom zkontroluje kontroln souet. A
pak namallokuje zjitn poet struktur. Kontroln souet je zde
kontrolovn proto, aby kvli vadnmu souboru nemallocoval
pli. Pestoe je kontroln souet je kontrolovn u zde, nemohu si
bt jist, e je tento soubor zcela v podku a tak nemohu si dovolit
ukldat natan informace pmo do stvajcch struktur a tm je
pepsat. Msto toho tedy pouvm statick promnn:

\dln [kq_pixmap *]loaded_pixmaps
\dln [kq_widget *]loaded_widgets
\dln [kq_widget *]loaded_hidwids
\dln [kq_submap *]loaded_submaps
\dln [kq_submap *]loaded_bgmap
\dln [kq_submap *]loaded_hidmap
\dln [kq_animpost *]loaded_anips
\dln [kq_postava *]loaded_posts
\dln [kq_timer *]loaded_timers
\dln [kq_timer *]loaded_pautims
\dln [kq_timer *]loaded_predmets
\dln [kq_timer *]loaded_pol
\dln [kq_timer *]loaded_apole
\ins c loaded

Funkce \dg [void] load_pocty() tedy vypad takto:

\ins c load_pocty

Po dokonen natn se mohou stt dv vci. Bu byl soubor naten
v~podku ("chyba == 0") nebo nebyl ("chyba == 1"). Pokud byl naten
v~podku je teba smazat pvodn struktury a nahradit je
natenmi. To dl funkce \dg [void] apply_load().

\ins c apply_load

Pokud natn sele, je dobr funkc \dg [void] free_loaded() uvolnt
z pamti to, co jsem namallokoval.

\ins c free_loaded

Dal funkce jsou u jen jednoduchmi ekvivalenty funkc z modulu
save. Nejdve uku ekvivalent k~funkci "save_kontexts", tedy funkci
\dg [void] load_kontexts(). Tato funkce neukld naten kontexty do
poloky "kontext" ve slov, ale do poloky "loaded_kontext". Do
poloky "kontext" se ulo a ve funkci "apply_load".

\ins c load_kontexts

Ekvivalent k funkci "save_word":

\dgn [kq_word *]load_word()
\ins c load_word

Ekvivalent k funkci "save_pixmaps":

\dgn [void] load_pixmaps()
\ins c load_pixmaps

Ekvivalent k funkci "save_pixmap":

\dgn [kq_pixmap *]load_pixmap()
\ins c load_pixmap

Ekvivalent k funkci "save_winfo":

\dgn [void] load_winfo
\ins c load_winfo

Ekvivalent k funkci "save_widgets":

\dgn [void] load_widgets
\ins c load_widgets

Ekvivalent k funkci "save_widget":

\dgn [kq_widget *]load_widget
\ins c load_widget

Ekvivalent k funkci "save_sminfo":

\dgn [void] load_sminfo
\ins c load_sminfo

Ekvivalent k funkci "save_submaps":

\dgn [void] load_submaps
\ins c load_submaps

Ekvivalent k funkci "save_submap":

\dgn [kq_submap *]load_submap
\ins c load_submap

Ekvivalent k funkci "save_anips":

\dgn [void] load_anips
\ins c load_anips

Ekvivalent k funkci "save_anip":

\dgn [kq_animpost *]load_anip
\ins c load_anip

Ekvivalent k funkci "save_posts":

\dgn [void] load_posts
\ins c load_posts

Ekvivalent k funkci "save_post":

\dgn [kq_post *]load_post
\ins c load_post

Ekvivalent k funkci "save_predmets":

\dgn [void] load_predmets
\ins c load_predmets

Ekvivalent k funkci "save_predmet":

\dgn [kq_predmet *]load_predmet
\ins c load_predmet

Ekvivalent k funkci "save_tinfo":

\dgn [void] load_tinfo
\ins c load_tinfo

Ekvivalent k funkci "save_timers":

\dgn [void] load_timers
\ins c load_timers

Ekvivalent k funkci "save_pol":

\dgn [kq_policko *]load_pol
\ins c load_pol

Ekvivalent k funkci "save_awid":

\dgn [kq_policko *]load_awid
\ins c load_awid

Ekvivalent k funkci "save_awids":

\dgn [kq_policko *]load_awids
\ins c load_awids

\subsec Registrovan funkce a promnn

Krom vech vnitnch struktur je teba ukldat jet njak dal
data, kter jsou uloena v jinch promnnch. Takovou promnnou je
teba zaregistrovat funkc "add_sl_var()". Tato funkce
dostane dva parametry. Ukazatel na onu promnnou a pak typ tto
promnn, tedy jak druh dat uchovv. K~dispozici jsou nsledujc
monosti:

\dgn SL_NULL \dgn SL_BOOL \dgn SL_TRIT \dgn SL_CHAR \dgn SL_INT
\dgn SL_FLOAT \dgn SL_COLOR \dgn SL_PIXMAP \dgn SL_WIDGET
\dgn SL_WIDGET \dgn SL_SUBMAP \dgn SL_ANIP \dgn SL_POST
\dgn SL_TIMER \dgn SL_POL \dgn SL_PREDM \dgn SL_WORD \dgn SL_AWID
\dgn SL_FUNC
\inss h sltypy

Funkce "add_sl_var" pak tuto promnnou zanese do seznamu struktury
\dg [struct] sl_var. Ta vypad takto:

\ins h sl_var

Funkce \dg add_sl_var tedy vypad takto:

\ins c add_sl_var

Pro uloen takto zaregistrovanch promnnch je k dispozici funkce
\dg [void] save_vars()

\ins c save_vars

Pro naten takto uloench hodnot existuje funkce \dg [void]
load_vars(). Tato funkce ulo natenou hodnotu do poloky "loaded" ve
struktue "sl_var". K uloen do skuten promnn, jej ukazatel je
v~poloce "ukazatel" dojde a ve funkci "apply_load".

\insl c load_vars

Pro ukldn a natn typ, kter jsou ukazatelem, pouvm
speciln funkce \dg [void] save_pointer() a
\dg [void *]load_pointer():

\inss c save_pointer

\insl c load_pointer

Tyto speciln funkce mm kvli registrovanm funkcm. Nkter
ukldan struktury obsahuj ukazatel na funkci a je teba njak
takovou funkci identifikovat. Pi ukldn takovch funkc je vybrno
ze seznamu a je uloeno poad nalezen funkce. Do toho seznamu ukld
dl funkce \dg [void] add_sl_func(). Tato funkce dostane ukazatel na
funkci a typ. Typ uruje typ parametru, kter m funkce dostat.

\inss c add_sl_func

Seznam funkc tvo struktura \dg [struct] sl_func:

\ins h sl_func

Poloka "typ" je ve struktue "sl_func" kvli timerm. V nich je toti
vyuvn "kq_pin" pro parametr funkce, ale datov typ "kq_pin"
neuruje, o jak typ pointeru se jedn. Funkce \dg save_func() pro
uloen funkce do souboru me jako druh parametr dostat ukazatel na
"kq_pin" a pak je uloe i obsah tohoto "kq_pin". V ppad,
e ukldan funkce dn parametr nem, je mon msto ukazatele
na "kq_pin" napsat "NULL".

\ins c save_func

Podobn funguje funkce \dg [void *]load_func(), kter vrt uloenou
funkci. Parametr tto funkce me bt "NULL" nebo ukazatel na
"kq_pin". Pokud to "NULL" nen, je do tohoto ukazatele uloeno to, co
tam uloila funkce "save_func".

\insl c load_func

Nkter funkce a promnn je dobr t zaregistrovan od zatku. To
zad funkce \dg [void] init_sl(), kter je sputna na zatku
programu funkc "kql_init".

\inss c init_sl

\subsec Vechno dohromady

Funkc pro ukldn a natn je vskutku hodn, a proto je vhodn je
zabalit do dal funkce, kter se ped jen nzev souboru, a ona
kompletn ulo nebo nate pozici. Vechny ukldac funkce jsou
shrnuty ve funkci \dg [void] save_all().

\inss c save_all

Vechny ukldac funkce jsou shrnuty ve funkci \dg [void] load_all().

\insl c load_all

Podobn, jako pedchoz funkce ukldaj a nataj pozici, zde na
stejnm principu existuj funkce, kter ukldaj nastaven a
historii. To je nateno pi startu programu a uloenu pi
ukonen. Konkrtn je tedy uloeno:

\begitems
\item * rychlost programu ("aktuFPS")
\item * velikost programu ("ratio")
\item * stav fullscreenu ("fullscreened"), ppadn velikost po
      	odfullscreenovn ("unfullratio")
\item * md text/win ("okrajwin")
\item * historie pkaz vetn aktuln napsanho
\enditems

\dgn [void] save_conf()
\inss c save_conf

Jeliko historie je uloena ve statickch promnnch modulu
\cite edit[m:edit], mm tam funkci "save_hist", kter tyto statick
promnn ulo do souboru  funkci "apply_loaded_hist", kter zkopruje
naten data do onch statickch promnnch.

Pi natn konfigurace si ponam podobn jako pi natn
pozice. Tedy ukldm si naten hodnoty a teprve v ppad spnho
naten jsou tato data uloena do ostrch promnnch. Promnn, do
kterch jsou data pechodn ukldna jsou vak v tomto ppad nejen
statick, ale i lokln a jsou ve tvaru "l_promenna".

\dgn [void] load_conf()
\insl c load_conf