struct kq_widget{
  kq_pixmap *obr; // Pixmapa widgetu
  Window okno; // to, co je videt
  int x,y;  // souradnice widgetu (pred zvetsenim)
  float z;    // Cim vetsi souradnice z, tim bliz je widget videt
  
  char hide;    // Timer je schovany
  char lokalni; /* 0 = S widgetem se pri prechodu na jine policko nic nedeje.
		   1 = Widget se znici pri prechodu.
		  -1 = Widget se schova pri prechodu. */

  kq_widget *next, *prev; /* okolni widgety v seznamu widgetu
					  souvisi s z-ovou souradnici */
  unsigned int cislo;
};

kq_widget *prvwidget; // prvni widget v seznamu widgetu (ten nejvice nahore)
kq_widget *poshidwid; // posledni schovany widget

void zmenratio(int oco); // zmeni ratio o oco a prescaluje hru

void rescale(int newrat); // prescaluje hru

kq_widget *vytvorwidget (int x, int y, float z, kq_pixmap *obrazek,
				char lokalni, char hide);
void ukazwidgety();

void posunwidget(kq_widget *w, int x, int y);
void posunzwidget(kq_widget *w, float z); // Zmeni z-ovou souradnici
void prebarviwidget(kq_widget *w, kq_pixmap *obrazek);
     // zmeni pixmapu widgetu

void zmenwidget(kq_widget *w, int x, int y, float z, kq_pixmap *obrazek);
     // zkratka pro posunwidget, posunzwidget a prebarviwidget

void hidewidget(kq_widget *w);
void unhidewidget(kq_widget *w);

void znicwidget(kq_widget *w);
void deletelwidgets();  // smaze lokalni widgety (pri prechodu na jine policko)
void deleteAwidgets();  // smaze vsechny widgety (pri nacitani pozice)

void vypiswidget(kq_widget *w);
void vypiswidgety();
